# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [Unreleased]

## [0.10.2] - 2025-06-10
### Added
- Added support for latest TypeDoc version 0.28.x.

## [0.10.1] - 2024-12-10
### Added
- Added support for latest TypeDoc version 0.27.x.

## [0.10.0] - 2024-07-28
### Added
- Added support for latest TypeDoc version 0.26.5 and above. (NOTE: older 0.26.x versions have a bug that breaks the plugin)

## [0.9.0] - 2023-04-28
### BREAKING CHANGES
- Removed the following options in favor of the new "style" option: backgroundColor, boxBackgroundColor, boxBorderColor, boxBorderRadius, boxBorderWidth, arrowColor, classFontName, classFontSize, classFontStyle, classFontColor, attributeFontName, attributeFontSize, attributeFontStyle and attributeFontColor
### Added
- New option "style" which let's you specify individual font settings for specific parts (for example: class name, property type, method return type, etc.) of the diagram
- Option "style.arrow.width" can now be used the specify the thickness of the arrows in the class diagrams
### Fixed
- Default value of option "hideShadow" adjusted to PlantUML's new default value: true

## [0.8.1] - 2024-04-25
### Fixed
- Plugin was not inserting diagrams into the documentation when using TypeDoc version 0.25.5 or above.
### Changes
- Updated dependencies

## [0.8.0] - 2023-09-17
### BREAKING CHANGES
- Removed support for TypeDoc versions 0.23.x due to a change in TypeDoc's handling of asynchronous tasks.
### Added
- Added support for latest TypeDoc version 0.25.x.
- The plugin now includes typings for its configuation that you can use in your TypeDoc config. (see example in README)

## [0.7.1] - 2023-04-23
### Changes
- Added support for latest TypeDoc version 0.24.x.

## [0.7.0] - 2022-07-24
### BREAKING CHANGES
- Support changed to TypeDoc versions 0.23.x due to a change in TypeDoc's HTML output.
### Changed
- Updated to TypeDoc version 0.23

## [0.6.1] - 2022-06-05
### Changed
- Updated dependencies to resolve their security vulnerabilities

## [0.6.0] - 2021-09-21
### BREAKING CHANGES
- Support changed to TypeDoc versions 0.22.x due to a breaking change in TypeDoc's output folder structure.
### Added
- New option "backgroundColor" to specify the background color of all class diagrams.
### Changed
- Background color of class diagrams defaults to "transparent" to better integrate with TypeDoc's new dark theme.

## [0.5.0] - 2021-08-08
### BREAKING CHANGES
- Support changed to TypeDoc versions >=0.21.0 due to a breaking change in TypeDoc's API.

## [0.4.0] - 2021-05-23
### BREAKING CHANGES
- Moved options to a single option object
  (see: [How to migrate from older versions to 0.4](https://github.com/krisztianb/typedoc-umlclass/blob/master/docs/migration/0.4.md))
### Added
- Automatic detection of CPU count
### Changed
- Updated dependencies
- Default value of option `generatorProcessCount` changed from `1` to number of available CPUs

## [0.3.2] - 2021-01-10
### Added
- Add support for newer TypeDoc versions: 0.20.14 and above (see: https://github.com/TypeStrong/typedoc/pull/1461)
- Add support for older TypeDoc versions: 0.17.x and 0.18.x

## [0.3.1] - 2020-12-22
### Added
- New option to specify the server for remote image URLs

## [0.3.0] - 2020-08-29
### Added
- Support of type parameter default values for template classes
### Changed
- Update to typedoc 0.19.0 and TypeScript 4

## [0.2.2] - 2020-07-25
### Added
- Class template parameters and arguments

## [0.2.1] - 2020-07-05
### Added
- New option to specify the order of class properties/methods
### Changed
- Diagram legends are not generated by default

## [0.2.0] - 2020-06-30
### Added
- New option to specify the number of JAVA/PlantUML processes to spawn
### Changed
- Don't spawn a separate JAVA/PlantUML process for every diagram

## [0.1.7] - 2020-06-26
### Added
- New option to generate a legend for the diagrams
### Fixed
- Double quotes around names of external types
- Wrong visibility of methods
- Class symbol sometimes visible for external types

## [0.1.6] - 2020-06-01
### Added
- Progress bar and option to hide it
- New option to output the generated PlantUML code into files
- New option for vebose output to debug the plugin
### Fixed
- External types without a reflection were not visible in the class diagrams
- Creating empty diagrams that block typedoc from finishing
- Types with complex names could lead to a PlantUML syntax error

## [0.1.5] - 2020-05-24
### Added
- Embed diagrams into HTML output
### Fixed
- Don't encode and decode PlantUML code when generating local image files

## [0.1.4] - 2020-05-19
### Added
- Include method parameters in the class diagram
- New option umlClassDiagramMethodParameterOutput
- CSS class for the HTML section
### Fixed
- Wrong types for attributes and method return values when using complex types

## [0.1.3] - 2020-05-17
### Added
- Include class name in local image filename
### Changed
- Default image format is now SVG
### Fixed
- Malformed local SVG image output

## [0.1.2] - 2020-05-13
### Added
- Faster PlantUML generation with caching

## [0.1.1] - 2020-05-10
### Added
- First version

[Unreleased]: https://github.com/krisztianb/typedoc-umlclass/compare/v0.10.2...HEAD
[0.10.2]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.10.2
[0.10.1]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.10.1
[0.10.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.10.0
[0.9.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.9.0
[0.8.1]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.8.1
[0.8.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.8.0
[0.7.1]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.7.1
[0.7.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.7.0
[0.6.1]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.6.1
[0.6.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.6.0
[0.5.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.5.0
[0.4.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.4.0
[0.3.2]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.3.2
[0.3.1]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.3.1
[0.3.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.3.0
[0.2.2]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.2.2
[0.2.1]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.2.1
[0.2.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.2.0
[0.1.7]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.7
[0.1.6]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.6
[0.1.5]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.5
[0.1.4]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.4
[0.1.3]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.3
[0.1.2]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.2
[0.1.1]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.1
