var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import * as os from "os";
import { cache } from "decorator-cache-getter";
import { ParameterType } from "typedoc";
/**
 * Class storing the options of the plugin.
 */
export class PluginOptions {
    /**
     * Returns how detailed the generated class diagrams should be.
     * @returns How detailed the generated class diagrams should be.
     */
    get type() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.type) !== null && _b !== void 0 ? _b : "detailed";
    }
    /**
     * Returns the location where the class diagrams should be stored.
     * @returns The location where the class diagrams should be stored.
     */
    get location() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.location) !== null && _b !== void 0 ? _b : "local";
    }
    /**
     * Returns the base URL used when generating remote images.
     * @returns The base URL used when generating remote images.
     */
    get remoteBaseUrl() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.remoteBaseUrl) !== null && _b !== void 0 ? _b : "http://www.plantuml.com";
    }
    /**
     * Returns the image format used for the class diagrams.
     * @returns The image format used for the class diagrams.
     */
    get format() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.format) !== null && _b !== void 0 ? _b : "svg";
    }
    /**
     * Returns the title that should be used for the section that contains the class diagrams.
     * @returns The title that should be used for the section that contains the class diagrams.
     */
    get sectionTitle() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.sectionTitle) !== null && _b !== void 0 ? _b : "Hierarchy-Diagram";
    }
    /**
     * Returns where on the page the class diagrams should be put.
     * @returns Where on the page the class diagrams should be put.
     */
    get position() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.position) !== null && _b !== void 0 ? _b : "above";
    }
    /**
     * Returns the type of legend that should be generated for the class diagrams.
     * @returns The type of legend that should be generated for the class diagrams.
     */
    get legendType() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.legendType) !== null && _b !== void 0 ? _b : "only-included";
    }
    /**
     * Returns how method parameters should be output in the class diagrams.
     * @returns How method parameters should be output in the class diagrams.
     */
    get methodParameterOutput() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.methodParameterOutput) !== null && _b !== void 0 ? _b : "complete";
    }
    /**
     * Returns how class members should be ordered in the class diagrams.
     * @returns How class members should be ordered the class diagrams.
     */
    get memberOrder() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.memberOrder) !== null && _b !== void 0 ? _b : "public-to-private";
    }
    /**
     * Returns the boundary before swiching from top->down to left->right direction for class diagrams.
     * @returns The boundary before swiching from top->down to left->right direction for class diagrams.
     */
    get topDownLayoutMaxSiblings() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.topDownLayoutMaxSiblings) !== null && _b !== void 0 ? _b : 6;
    }
    /**
     * Returns how the member visibility is rendered in the class diagrams.
     * @returns How the member visibility is rendered in the class diagrams.
     */
    get visibilityStyle() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.visibilityStyle) !== null && _b !== void 0 ? _b : "icon";
    }
    /**
     * Returns whether to hide empty properties and methods in the class diagrams.
     * @returns Whether to hide empty properties and methods in the class diagrams.
     */
    get hideEmptyMembers() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.hideEmptyMembers) !== null && _b !== void 0 ? _b : true;
    }
    /**
     * Returns whether to hide the circled character in front of class names for class diagrams.
     * @returns Whether to hide the circled character in front of class names for class diagrams.
     */
    get hideCircledChar() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.hideCircledChar) !== null && _b !== void 0 ? _b : false;
    }
    /**
     * Returns whether to hide the shadows in the class diagrams.
     * @returns Whether to hide the shadows in the class diagrams.
     */
    get hideShadow() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.hideShadow) !== null && _b !== void 0 ? _b : true;
    }
    /**
     * Returns the color that should be used for the background of all class diagrams.
     * @returns The color that should be used for the background of all class diagrams.
     */
    get backgroundColor() {
        var _a, _b, _c;
        return (_c = (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.style) === null || _b === void 0 ? void 0 : _b.backgroundColor) !== null && _c !== void 0 ? _c : "transparent";
    }
    /**
     * Returns the style that should be used for boxes in the class diagrams.
     * @returns The style that should be used for boxes in the class diagrams.
     */
    get box() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j;
        const userBoxStyle = (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.style) === null || _b === void 0 ? void 0 : _b.box;
        return {
            backgroundColor: (_c = userBoxStyle === null || userBoxStyle === void 0 ? void 0 : userBoxStyle.backgroundColor) !== null && _c !== void 0 ? _c : "",
            border: {
                width: (_e = (_d = userBoxStyle === null || userBoxStyle === void 0 ? void 0 : userBoxStyle.border) === null || _d === void 0 ? void 0 : _d.width) !== null && _e !== void 0 ? _e : -1, // because 0 can be used to hide borders
                color: (_g = (_f = userBoxStyle === null || userBoxStyle === void 0 ? void 0 : userBoxStyle.border) === null || _f === void 0 ? void 0 : _f.color) !== null && _g !== void 0 ? _g : "",
                radius: (_j = (_h = userBoxStyle === null || userBoxStyle === void 0 ? void 0 : userBoxStyle.border) === null || _h === void 0 ? void 0 : _h.radius) !== null && _j !== void 0 ? _j : 0,
            },
        };
    }
    /**
     * Returns the style that should be used for arrows in the class diagrams.
     * @returns The style that should be used for arrows in the class diagrams.
     */
    get arrow() {
        var _a, _b, _c, _d;
        const userArrowtyle = (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.style) === null || _b === void 0 ? void 0 : _b.arrow;
        return {
            width: (_c = userArrowtyle === null || userArrowtyle === void 0 ? void 0 : userArrowtyle.width) !== null && _c !== void 0 ? _c : -1,
            color: (_d = userArrowtyle === null || userArrowtyle === void 0 ? void 0 : userArrowtyle.color) !== null && _d !== void 0 ? _d : "",
        };
    }
    /**
     * Returns the style that should be used for classes in the class diagrams.
     * @returns The style that should be used for classes in the class diagrams.
     */
    get class() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15;
        const userTextStyle = (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.style) === null || _b === void 0 ? void 0 : _b.text;
        const userClassStyle = (_d = (_c = this.userValues) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.class;
        return {
            name: {
                font: {
                    family: (_j = (_g = (_f = (_e = userClassStyle === null || userClassStyle === void 0 ? void 0 : userClassStyle.name) === null || _e === void 0 ? void 0 : _e.font) === null || _f === void 0 ? void 0 : _f.family) !== null && _g !== void 0 ? _g : (_h = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _h === void 0 ? void 0 : _h.family) !== null && _j !== void 0 ? _j : "",
                    size: (_p = (_m = (_l = (_k = userClassStyle === null || userClassStyle === void 0 ? void 0 : userClassStyle.name) === null || _k === void 0 ? void 0 : _k.font) === null || _l === void 0 ? void 0 : _l.size) !== null && _m !== void 0 ? _m : (_o = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _o === void 0 ? void 0 : _o.size) !== null && _p !== void 0 ? _p : 0,
                    bold: (_u = (_s = (_r = (_q = userClassStyle === null || userClassStyle === void 0 ? void 0 : userClassStyle.name) === null || _q === void 0 ? void 0 : _q.font) === null || _r === void 0 ? void 0 : _r.bold) !== null && _s !== void 0 ? _s : (_t = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _t === void 0 ? void 0 : _t.bold) !== null && _u !== void 0 ? _u : false,
                    italic: (_z = (_x = (_w = (_v = userClassStyle === null || userClassStyle === void 0 ? void 0 : userClassStyle.name) === null || _v === void 0 ? void 0 : _v.font) === null || _w === void 0 ? void 0 : _w.italic) !== null && _x !== void 0 ? _x : (_y = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _y === void 0 ? void 0 : _y.italic) !== null && _z !== void 0 ? _z : false,
                    underline: (_4 = (_2 = (_1 = (_0 = userClassStyle === null || userClassStyle === void 0 ? void 0 : userClassStyle.name) === null || _0 === void 0 ? void 0 : _0.font) === null || _1 === void 0 ? void 0 : _1.underline) !== null && _2 !== void 0 ? _2 : (_3 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _3 === void 0 ? void 0 : _3.underline) !== null && _4 !== void 0 ? _4 : false,
                    strikeout: (_9 = (_7 = (_6 = (_5 = userClassStyle === null || userClassStyle === void 0 ? void 0 : userClassStyle.name) === null || _5 === void 0 ? void 0 : _5.font) === null || _6 === void 0 ? void 0 : _6.strikeout) !== null && _7 !== void 0 ? _7 : (_8 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _8 === void 0 ? void 0 : _8.strikeout) !== null && _9 !== void 0 ? _9 : false,
                },
                color: (_12 = (_11 = (_10 = userClassStyle === null || userClassStyle === void 0 ? void 0 : userClassStyle.name) === null || _10 === void 0 ? void 0 : _10.color) !== null && _11 !== void 0 ? _11 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.color) !== null && _12 !== void 0 ? _12 : "",
                backgroundColor: (_15 = (_14 = (_13 = userClassStyle === null || userClassStyle === void 0 ? void 0 : userClassStyle.name) === null || _13 === void 0 ? void 0 : _13.backgroundColor) !== null && _14 !== void 0 ? _14 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.backgroundColor) !== null && _15 !== void 0 ? _15 : "",
            },
        };
    }
    /**
     * Returns the style that should be used for interfaces in the class diagrams.
     * @returns The style that should be used for interfaces in the class diagrams.
     */
    get interface() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15;
        const userTextStyle = (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.style) === null || _b === void 0 ? void 0 : _b.text;
        const userInterfaceStyle = (_d = (_c = this.userValues) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.interface;
        return {
            name: {
                font: {
                    family: (_j = (_g = (_f = (_e = userInterfaceStyle === null || userInterfaceStyle === void 0 ? void 0 : userInterfaceStyle.name) === null || _e === void 0 ? void 0 : _e.font) === null || _f === void 0 ? void 0 : _f.family) !== null && _g !== void 0 ? _g : (_h = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _h === void 0 ? void 0 : _h.family) !== null && _j !== void 0 ? _j : "",
                    size: (_p = (_m = (_l = (_k = userInterfaceStyle === null || userInterfaceStyle === void 0 ? void 0 : userInterfaceStyle.name) === null || _k === void 0 ? void 0 : _k.font) === null || _l === void 0 ? void 0 : _l.size) !== null && _m !== void 0 ? _m : (_o = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _o === void 0 ? void 0 : _o.size) !== null && _p !== void 0 ? _p : 0,
                    bold: (_u = (_s = (_r = (_q = userInterfaceStyle === null || userInterfaceStyle === void 0 ? void 0 : userInterfaceStyle.name) === null || _q === void 0 ? void 0 : _q.font) === null || _r === void 0 ? void 0 : _r.bold) !== null && _s !== void 0 ? _s : (_t = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _t === void 0 ? void 0 : _t.bold) !== null && _u !== void 0 ? _u : false,
                    italic: (_z = (_x = (_w = (_v = userInterfaceStyle === null || userInterfaceStyle === void 0 ? void 0 : userInterfaceStyle.name) === null || _v === void 0 ? void 0 : _v.font) === null || _w === void 0 ? void 0 : _w.italic) !== null && _x !== void 0 ? _x : (_y = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _y === void 0 ? void 0 : _y.italic) !== null && _z !== void 0 ? _z : false,
                    underline: (_4 = (_2 = (_1 = (_0 = userInterfaceStyle === null || userInterfaceStyle === void 0 ? void 0 : userInterfaceStyle.name) === null || _0 === void 0 ? void 0 : _0.font) === null || _1 === void 0 ? void 0 : _1.underline) !== null && _2 !== void 0 ? _2 : (_3 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _3 === void 0 ? void 0 : _3.underline) !== null && _4 !== void 0 ? _4 : false,
                    strikeout: (_9 = (_7 = (_6 = (_5 = userInterfaceStyle === null || userInterfaceStyle === void 0 ? void 0 : userInterfaceStyle.name) === null || _5 === void 0 ? void 0 : _5.font) === null || _6 === void 0 ? void 0 : _6.strikeout) !== null && _7 !== void 0 ? _7 : (_8 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _8 === void 0 ? void 0 : _8.strikeout) !== null && _9 !== void 0 ? _9 : false,
                },
                color: (_12 = (_11 = (_10 = userInterfaceStyle === null || userInterfaceStyle === void 0 ? void 0 : userInterfaceStyle.name) === null || _10 === void 0 ? void 0 : _10.color) !== null && _11 !== void 0 ? _11 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.color) !== null && _12 !== void 0 ? _12 : "",
                backgroundColor: (_15 = (_14 = (_13 = userInterfaceStyle === null || userInterfaceStyle === void 0 ? void 0 : userInterfaceStyle.name) === null || _13 === void 0 ? void 0 : _13.backgroundColor) !== null && _14 !== void 0 ? _14 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.backgroundColor) !== null && _15 !== void 0 ? _15 : "",
            },
        };
    }
    /**
     * Returns the style that should be used for properties in the class diagrams.
     * @returns The style that should be used for properties in the class diagrams.
     */
    get property() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39, _40, _41, _42, _43, _44, _45, _46, _47, _48, _49, _50, _51;
        const userTextStyle = (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.style) === null || _b === void 0 ? void 0 : _b.text;
        const userPropertyStyle = (_d = (_c = this.userValues) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.property;
        return {
            name: {
                font: {
                    family: (_j = (_g = (_f = (_e = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.name) === null || _e === void 0 ? void 0 : _e.font) === null || _f === void 0 ? void 0 : _f.family) !== null && _g !== void 0 ? _g : (_h = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _h === void 0 ? void 0 : _h.family) !== null && _j !== void 0 ? _j : "",
                    size: (_p = (_m = (_l = (_k = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.name) === null || _k === void 0 ? void 0 : _k.font) === null || _l === void 0 ? void 0 : _l.size) !== null && _m !== void 0 ? _m : (_o = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _o === void 0 ? void 0 : _o.size) !== null && _p !== void 0 ? _p : 0,
                    bold: (_u = (_s = (_r = (_q = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.name) === null || _q === void 0 ? void 0 : _q.font) === null || _r === void 0 ? void 0 : _r.bold) !== null && _s !== void 0 ? _s : (_t = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _t === void 0 ? void 0 : _t.bold) !== null && _u !== void 0 ? _u : false,
                    italic: (_z = (_x = (_w = (_v = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.name) === null || _v === void 0 ? void 0 : _v.font) === null || _w === void 0 ? void 0 : _w.italic) !== null && _x !== void 0 ? _x : (_y = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _y === void 0 ? void 0 : _y.italic) !== null && _z !== void 0 ? _z : false,
                    underline: (_4 = (_2 = (_1 = (_0 = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.name) === null || _0 === void 0 ? void 0 : _0.font) === null || _1 === void 0 ? void 0 : _1.underline) !== null && _2 !== void 0 ? _2 : (_3 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _3 === void 0 ? void 0 : _3.underline) !== null && _4 !== void 0 ? _4 : false,
                    strikeout: (_9 = (_7 = (_6 = (_5 = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.name) === null || _5 === void 0 ? void 0 : _5.font) === null || _6 === void 0 ? void 0 : _6.strikeout) !== null && _7 !== void 0 ? _7 : (_8 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _8 === void 0 ? void 0 : _8.strikeout) !== null && _9 !== void 0 ? _9 : false,
                },
                color: (_12 = (_11 = (_10 = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.name) === null || _10 === void 0 ? void 0 : _10.color) !== null && _11 !== void 0 ? _11 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.color) !== null && _12 !== void 0 ? _12 : "",
                backgroundColor: (_15 = (_14 = (_13 = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.name) === null || _13 === void 0 ? void 0 : _13.backgroundColor) !== null && _14 !== void 0 ? _14 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.backgroundColor) !== null && _15 !== void 0 ? _15 : "",
            },
            type: {
                font: {
                    family: (_20 = (_18 = (_17 = (_16 = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.type) === null || _16 === void 0 ? void 0 : _16.font) === null || _17 === void 0 ? void 0 : _17.family) !== null && _18 !== void 0 ? _18 : (_19 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _19 === void 0 ? void 0 : _19.family) !== null && _20 !== void 0 ? _20 : "",
                    size: (_25 = (_23 = (_22 = (_21 = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.type) === null || _21 === void 0 ? void 0 : _21.font) === null || _22 === void 0 ? void 0 : _22.size) !== null && _23 !== void 0 ? _23 : (_24 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _24 === void 0 ? void 0 : _24.size) !== null && _25 !== void 0 ? _25 : 0,
                    bold: (_30 = (_28 = (_27 = (_26 = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.type) === null || _26 === void 0 ? void 0 : _26.font) === null || _27 === void 0 ? void 0 : _27.bold) !== null && _28 !== void 0 ? _28 : (_29 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _29 === void 0 ? void 0 : _29.bold) !== null && _30 !== void 0 ? _30 : false,
                    italic: (_35 = (_33 = (_32 = (_31 = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.type) === null || _31 === void 0 ? void 0 : _31.font) === null || _32 === void 0 ? void 0 : _32.italic) !== null && _33 !== void 0 ? _33 : (_34 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _34 === void 0 ? void 0 : _34.italic) !== null && _35 !== void 0 ? _35 : false,
                    underline: (_40 = (_38 = (_37 = (_36 = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.type) === null || _36 === void 0 ? void 0 : _36.font) === null || _37 === void 0 ? void 0 : _37.underline) !== null && _38 !== void 0 ? _38 : (_39 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _39 === void 0 ? void 0 : _39.underline) !== null && _40 !== void 0 ? _40 : false,
                    strikeout: (_45 = (_43 = (_42 = (_41 = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.type) === null || _41 === void 0 ? void 0 : _41.font) === null || _42 === void 0 ? void 0 : _42.strikeout) !== null && _43 !== void 0 ? _43 : (_44 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _44 === void 0 ? void 0 : _44.strikeout) !== null && _45 !== void 0 ? _45 : false,
                },
                color: (_48 = (_47 = (_46 = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.type) === null || _46 === void 0 ? void 0 : _46.color) !== null && _47 !== void 0 ? _47 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.color) !== null && _48 !== void 0 ? _48 : "",
                backgroundColor: (_51 = (_50 = (_49 = userPropertyStyle === null || userPropertyStyle === void 0 ? void 0 : userPropertyStyle.type) === null || _49 === void 0 ? void 0 : _49.backgroundColor) !== null && _50 !== void 0 ? _50 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.backgroundColor) !== null && _51 !== void 0 ? _51 : "",
            },
        };
    }
    /**
     * Returns the style that should be used for properties in the class diagrams.
     * @returns The style that should be used for properties in the class diagrams.
     */
    get method() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39, _40, _41, _42, _43, _44, _45, _46, _47, _48, _49, _50, _51, _52, _53, _54, _55, _56, _57, _58, _59, _60, _61, _62, _63, _64, _65, _66, _67, _68, _69, _70, _71, _72, _73, _74, _75, _76, _77, _78, _79, _80, _81, _82, _83, _84, _85, _86, _87, _88, _89, _90, _91, _92, _93, _94, _95, _96, _97, _98, _99, _100, _101, _102, _103, _104, _105, _106, _107, _108, _109, _110, _111, _112, _113, _114, _115, _116, _117, _118, _119, _120, _121, _122, _123, _124, _125, _126, _127, _128, _129, _130, _131, _132, _133, _134, _135, _136, _137, _138, _139;
        const userTextStyle = (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.style) === null || _b === void 0 ? void 0 : _b.text;
        const userMethodStyle = (_d = (_c = this.userValues) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.method;
        return {
            name: {
                font: {
                    family: (_j = (_g = (_f = (_e = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.name) === null || _e === void 0 ? void 0 : _e.font) === null || _f === void 0 ? void 0 : _f.family) !== null && _g !== void 0 ? _g : (_h = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _h === void 0 ? void 0 : _h.family) !== null && _j !== void 0 ? _j : "",
                    size: (_p = (_m = (_l = (_k = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.name) === null || _k === void 0 ? void 0 : _k.font) === null || _l === void 0 ? void 0 : _l.size) !== null && _m !== void 0 ? _m : (_o = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _o === void 0 ? void 0 : _o.size) !== null && _p !== void 0 ? _p : 0,
                    bold: (_u = (_s = (_r = (_q = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.name) === null || _q === void 0 ? void 0 : _q.font) === null || _r === void 0 ? void 0 : _r.bold) !== null && _s !== void 0 ? _s : (_t = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _t === void 0 ? void 0 : _t.bold) !== null && _u !== void 0 ? _u : false,
                    italic: (_z = (_x = (_w = (_v = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.name) === null || _v === void 0 ? void 0 : _v.font) === null || _w === void 0 ? void 0 : _w.italic) !== null && _x !== void 0 ? _x : (_y = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _y === void 0 ? void 0 : _y.italic) !== null && _z !== void 0 ? _z : false,
                    underline: (_4 = (_2 = (_1 = (_0 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.name) === null || _0 === void 0 ? void 0 : _0.font) === null || _1 === void 0 ? void 0 : _1.underline) !== null && _2 !== void 0 ? _2 : (_3 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _3 === void 0 ? void 0 : _3.underline) !== null && _4 !== void 0 ? _4 : false,
                    strikeout: (_9 = (_7 = (_6 = (_5 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.name) === null || _5 === void 0 ? void 0 : _5.font) === null || _6 === void 0 ? void 0 : _6.strikeout) !== null && _7 !== void 0 ? _7 : (_8 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _8 === void 0 ? void 0 : _8.strikeout) !== null && _9 !== void 0 ? _9 : false,
                },
                color: (_12 = (_11 = (_10 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.name) === null || _10 === void 0 ? void 0 : _10.color) !== null && _11 !== void 0 ? _11 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.color) !== null && _12 !== void 0 ? _12 : "",
                backgroundColor: (_15 = (_14 = (_13 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.name) === null || _13 === void 0 ? void 0 : _13.backgroundColor) !== null && _14 !== void 0 ? _14 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.backgroundColor) !== null && _15 !== void 0 ? _15 : "",
            },
            parameter: {
                name: {
                    font: {
                        family: (_21 = (_19 = (_18 = (_17 = (_16 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _16 === void 0 ? void 0 : _16.name) === null || _17 === void 0 ? void 0 : _17.font) === null || _18 === void 0 ? void 0 : _18.family) !== null && _19 !== void 0 ? _19 : (_20 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _20 === void 0 ? void 0 : _20.family) !== null && _21 !== void 0 ? _21 : "",
                        size: (_27 = (_25 = (_24 = (_23 = (_22 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _22 === void 0 ? void 0 : _22.name) === null || _23 === void 0 ? void 0 : _23.font) === null || _24 === void 0 ? void 0 : _24.size) !== null && _25 !== void 0 ? _25 : (_26 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _26 === void 0 ? void 0 : _26.size) !== null && _27 !== void 0 ? _27 : 0,
                        bold: (_33 = (_31 = (_30 = (_29 = (_28 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _28 === void 0 ? void 0 : _28.name) === null || _29 === void 0 ? void 0 : _29.font) === null || _30 === void 0 ? void 0 : _30.bold) !== null && _31 !== void 0 ? _31 : (_32 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _32 === void 0 ? void 0 : _32.bold) !== null && _33 !== void 0 ? _33 : false,
                        italic: (_39 = (_37 = (_36 = (_35 = (_34 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _34 === void 0 ? void 0 : _34.name) === null || _35 === void 0 ? void 0 : _35.font) === null || _36 === void 0 ? void 0 : _36.italic) !== null && _37 !== void 0 ? _37 : (_38 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _38 === void 0 ? void 0 : _38.italic) !== null && _39 !== void 0 ? _39 : false,
                        underline: (_45 = (_43 = (_42 = (_41 = (_40 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _40 === void 0 ? void 0 : _40.name) === null || _41 === void 0 ? void 0 : _41.font) === null || _42 === void 0 ? void 0 : _42.underline) !== null && _43 !== void 0 ? _43 : (_44 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _44 === void 0 ? void 0 : _44.underline) !== null && _45 !== void 0 ? _45 : false,
                        strikeout: (_51 = (_49 = (_48 = (_47 = (_46 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _46 === void 0 ? void 0 : _46.name) === null || _47 === void 0 ? void 0 : _47.font) === null || _48 === void 0 ? void 0 : _48.strikeout) !== null && _49 !== void 0 ? _49 : (_50 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _50 === void 0 ? void 0 : _50.strikeout) !== null && _51 !== void 0 ? _51 : false,
                    },
                    color: (_55 = (_54 = (_53 = (_52 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _52 === void 0 ? void 0 : _52.name) === null || _53 === void 0 ? void 0 : _53.color) !== null && _54 !== void 0 ? _54 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.color) !== null && _55 !== void 0 ? _55 : "",
                    backgroundColor: (_59 = (_58 = (_57 = (_56 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _56 === void 0 ? void 0 : _56.name) === null || _57 === void 0 ? void 0 : _57.backgroundColor) !== null && _58 !== void 0 ? _58 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.backgroundColor) !== null && _59 !== void 0 ? _59 : "",
                },
                type: {
                    font: {
                        family: (_65 = (_63 = (_62 = (_61 = (_60 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _60 === void 0 ? void 0 : _60.type) === null || _61 === void 0 ? void 0 : _61.font) === null || _62 === void 0 ? void 0 : _62.family) !== null && _63 !== void 0 ? _63 : (_64 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _64 === void 0 ? void 0 : _64.family) !== null && _65 !== void 0 ? _65 : "",
                        size: (_71 = (_69 = (_68 = (_67 = (_66 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _66 === void 0 ? void 0 : _66.type) === null || _67 === void 0 ? void 0 : _67.font) === null || _68 === void 0 ? void 0 : _68.size) !== null && _69 !== void 0 ? _69 : (_70 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _70 === void 0 ? void 0 : _70.size) !== null && _71 !== void 0 ? _71 : 0,
                        bold: (_77 = (_75 = (_74 = (_73 = (_72 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _72 === void 0 ? void 0 : _72.type) === null || _73 === void 0 ? void 0 : _73.font) === null || _74 === void 0 ? void 0 : _74.bold) !== null && _75 !== void 0 ? _75 : (_76 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _76 === void 0 ? void 0 : _76.bold) !== null && _77 !== void 0 ? _77 : false,
                        italic: (_83 = (_81 = (_80 = (_79 = (_78 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _78 === void 0 ? void 0 : _78.type) === null || _79 === void 0 ? void 0 : _79.font) === null || _80 === void 0 ? void 0 : _80.italic) !== null && _81 !== void 0 ? _81 : (_82 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _82 === void 0 ? void 0 : _82.italic) !== null && _83 !== void 0 ? _83 : false,
                        underline: (_89 = (_87 = (_86 = (_85 = (_84 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _84 === void 0 ? void 0 : _84.type) === null || _85 === void 0 ? void 0 : _85.font) === null || _86 === void 0 ? void 0 : _86.underline) !== null && _87 !== void 0 ? _87 : (_88 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _88 === void 0 ? void 0 : _88.underline) !== null && _89 !== void 0 ? _89 : false,
                        strikeout: (_95 = (_93 = (_92 = (_91 = (_90 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _90 === void 0 ? void 0 : _90.type) === null || _91 === void 0 ? void 0 : _91.font) === null || _92 === void 0 ? void 0 : _92.strikeout) !== null && _93 !== void 0 ? _93 : (_94 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _94 === void 0 ? void 0 : _94.strikeout) !== null && _95 !== void 0 ? _95 : false,
                    },
                    color: (_99 = (_98 = (_97 = (_96 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _96 === void 0 ? void 0 : _96.type) === null || _97 === void 0 ? void 0 : _97.color) !== null && _98 !== void 0 ? _98 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.color) !== null && _99 !== void 0 ? _99 : "",
                    backgroundColor: (_103 = (_102 = (_101 = (_100 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.parameter) === null || _100 === void 0 ? void 0 : _100.type) === null || _101 === void 0 ? void 0 : _101.backgroundColor) !== null && _102 !== void 0 ? _102 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.backgroundColor) !== null && _103 !== void 0 ? _103 : "",
                },
            },
            returnType: {
                font: {
                    family: (_108 = (_106 = (_105 = (_104 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.returnType) === null || _104 === void 0 ? void 0 : _104.font) === null || _105 === void 0 ? void 0 : _105.family) !== null && _106 !== void 0 ? _106 : (_107 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _107 === void 0 ? void 0 : _107.family) !== null && _108 !== void 0 ? _108 : "",
                    size: (_113 = (_111 = (_110 = (_109 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.returnType) === null || _109 === void 0 ? void 0 : _109.font) === null || _110 === void 0 ? void 0 : _110.size) !== null && _111 !== void 0 ? _111 : (_112 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _112 === void 0 ? void 0 : _112.size) !== null && _113 !== void 0 ? _113 : 0,
                    bold: (_118 = (_116 = (_115 = (_114 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.returnType) === null || _114 === void 0 ? void 0 : _114.font) === null || _115 === void 0 ? void 0 : _115.bold) !== null && _116 !== void 0 ? _116 : (_117 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _117 === void 0 ? void 0 : _117.bold) !== null && _118 !== void 0 ? _118 : false,
                    italic: (_123 = (_121 = (_120 = (_119 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.returnType) === null || _119 === void 0 ? void 0 : _119.font) === null || _120 === void 0 ? void 0 : _120.italic) !== null && _121 !== void 0 ? _121 : (_122 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _122 === void 0 ? void 0 : _122.italic) !== null && _123 !== void 0 ? _123 : false,
                    underline: (_128 = (_126 = (_125 = (_124 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.returnType) === null || _124 === void 0 ? void 0 : _124.font) === null || _125 === void 0 ? void 0 : _125.underline) !== null && _126 !== void 0 ? _126 : (_127 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _127 === void 0 ? void 0 : _127.underline) !== null && _128 !== void 0 ? _128 : false,
                    strikeout: (_133 = (_131 = (_130 = (_129 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.returnType) === null || _129 === void 0 ? void 0 : _129.font) === null || _130 === void 0 ? void 0 : _130.strikeout) !== null && _131 !== void 0 ? _131 : (_132 = userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.font) === null || _132 === void 0 ? void 0 : _132.strikeout) !== null && _133 !== void 0 ? _133 : false,
                },
                color: (_136 = (_135 = (_134 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.returnType) === null || _134 === void 0 ? void 0 : _134.color) !== null && _135 !== void 0 ? _135 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.color) !== null && _136 !== void 0 ? _136 : "",
                backgroundColor: (_139 = (_138 = (_137 = userMethodStyle === null || userMethodStyle === void 0 ? void 0 : userMethodStyle.returnType) === null || _137 === void 0 ? void 0 : _137.backgroundColor) !== null && _138 !== void 0 ? _138 : userTextStyle === null || userTextStyle === void 0 ? void 0 : userTextStyle.backgroundColor) !== null && _139 !== void 0 ? _139 : "",
            },
        };
    }
    /**
     * Returns the number of PlantUML processes that should be used for generating the class diagrams.
     * @returns The number of PlantUML processes that should be used for generating the class diagrams.
     */
    get generatorProcessCount() {
        var _a, _b;
        const processCount = (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.generatorProcessCount) !== null && _b !== void 0 ? _b : -1;
        return processCount <= 0 ? os.cpus().length : processCount;
    }
    /**
     * Returns whether to hide the progress bar while generating the class diagrams.
     * @returns True, if the progress bar should not be displayed while generating the class diagrams, otherwise false.
     */
    get hideProgressBar() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.hideProgressBar) !== null && _b !== void 0 ? _b : false;
    }
    /**
     * Returns whether to create files containing the PlantUML code for the class diagrams.
     * @returns True, if files with the PlantUML code should be created, otherwise false.
     */
    get createPlantUmlFiles() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.createPlantUmlFiles) !== null && _b !== void 0 ? _b : false;
    }
    /**
     * Returns whether the plugin should output verbose info during its work.
     * @returns True, if plugin should create verbose output, otherwise false.
     */
    get createVerboseOutput() {
        var _a, _b;
        return (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.verboseOutput) !== null && _b !== void 0 ? _b : false;
    }
    /**
     * Returns whether any text should be styled with an italic font.
     * @returns True if anything should be styled with an italic font, otherwise false.
     */
    get isAnythingStyledItalic() {
        var _a, _b, _c, _d, _e;
        return (((_e = (_d = (_c = (_b = (_a = this.userValues) === null || _a === void 0 ? void 0 : _a.style) === null || _b === void 0 ? void 0 : _b.text) === null || _c === void 0 ? void 0 : _c.font) === null || _d === void 0 ? void 0 : _d.italic) !== null && _e !== void 0 ? _e : false) ||
            this.class.name.font.italic ||
            this.interface.name.font.italic ||
            this.property.name.font.italic ||
            this.property.type.font.italic ||
            this.method.name.font.italic ||
            this.method.parameter.name.font.italic ||
            this.method.parameter.type.font.italic ||
            this.method.returnType.font.italic);
    }
    /**
     * Adds the command line options of the plugin to the TypeDoc application.
     * @param typedoc The TypeDoc application.
     */
    // eslint-disable-next-line class-methods-use-this
    addToApplication(typedoc) {
        typedoc.options.addDeclaration({
            type: ParameterType.Mixed,
            name: "umlClassDiagram",
            help: "The object defining the options of the typedoc-umlclass plugin.",
        });
    }
    /**
     * Reads the values of the plugin options from the application options.
     * @param typedoc The TypeDoc application.
     */
    readValuesFromApplication(typedoc) {
        // Yes, this type assertion sucks, but there's something wrong with the Type Definitions of TypeDoc
        this.userValues = typedoc.options.getValue("umlClassDiagram");
    }
}
__decorate([
    cache
], PluginOptions.prototype, "type", null);
__decorate([
    cache
], PluginOptions.prototype, "location", null);
__decorate([
    cache
], PluginOptions.prototype, "remoteBaseUrl", null);
__decorate([
    cache
], PluginOptions.prototype, "format", null);
__decorate([
    cache
], PluginOptions.prototype, "sectionTitle", null);
__decorate([
    cache
], PluginOptions.prototype, "position", null);
__decorate([
    cache
], PluginOptions.prototype, "legendType", null);
__decorate([
    cache
], PluginOptions.prototype, "methodParameterOutput", null);
__decorate([
    cache
], PluginOptions.prototype, "memberOrder", null);
__decorate([
    cache
], PluginOptions.prototype, "topDownLayoutMaxSiblings", null);
__decorate([
    cache
], PluginOptions.prototype, "visibilityStyle", null);
__decorate([
    cache
], PluginOptions.prototype, "hideEmptyMembers", null);
__decorate([
    cache
], PluginOptions.prototype, "hideCircledChar", null);
__decorate([
    cache
], PluginOptions.prototype, "hideShadow", null);
__decorate([
    cache
], PluginOptions.prototype, "backgroundColor", null);
__decorate([
    cache
], PluginOptions.prototype, "box", null);
__decorate([
    cache
], PluginOptions.prototype, "arrow", null);
__decorate([
    cache
], PluginOptions.prototype, "class", null);
__decorate([
    cache
], PluginOptions.prototype, "interface", null);
__decorate([
    cache
], PluginOptions.prototype, "property", null);
__decorate([
    cache
], PluginOptions.prototype, "method", null);
__decorate([
    cache
], PluginOptions.prototype, "generatorProcessCount", null);
__decorate([
    cache
], PluginOptions.prototype, "hideProgressBar", null);
__decorate([
    cache
], PluginOptions.prototype, "createPlantUmlFiles", null);
__decorate([
    cache
], PluginOptions.prototype, "createVerboseOutput", null);
__decorate([
    cache
], PluginOptions.prototype, "isAnythingStyledItalic", null);
