import { type PageSections } from "./page_section.js";
/**
 * Helper class for modifying TypeDoc page content.
 */
export declare class PageProcessor {
    /** The current content of the page. */
    private _content;
    /**
     * Creates a new PageProcessor with the content of the page.
     * @param content The content of the page.
     */
    constructor(content?: string);
    /**
     * Returns the current content of the page.
     * @returns The current content of the page.
     */
    get content(): string;
    /**
     * Inserts new content above a given section.
     * @param section The section above which the content should be inserted.
     * @param newContent The content to insert.
     */
    insertAboveSection(section: PageSections, newContent: string): void;
    /**
     * Inserts new content below a given section.
     * @param section The section below which the content should be inserted.
     * @param newContent The content to insert.
     */
    insertBelowSection(section: PageSections, newContent: string): void;
}
