/**
 * Well known sections of a TypeDoc page.
 */
export declare const enum PageSections {
    Hierarchy = "Hierarchy"
}
/**
 * Creates HTML for a section containing a hierarchy diagram.
 * @param title The title of the section.
 * @param imageUrl The URL to the hierarchy diagram.
 * @param reflectionName The name of the reflection for which the hierarchy diagram was generated.
 * @param legendHtml Possbile HTML for the diagram's legend.
 * @returns The HTML for the section.
 */
export declare function createHierarchyDiagramSection(title: string, imageUrl: string, reflectionName: string, legendHtml?: string): string;
