import { DeclarationReflection, ReferenceType } from "typedoc";
/**
 * Returns the types the given reflection is extending.
 * @param reflection The reflection whoes extended types are wanted.
 * @returns The types the given reflection is extending.
 */
export declare function getExtendedTypesForReflection(reflection: Readonly<DeclarationReflection>): ReferenceType[];
/**
 * Returns the types that are extending the given reflection.
 * @param reflection The reflection whoes sub types are wanted.
 * @returns The types that are extending the given reflection.
 */
export declare function getExtendedBysForReflection(reflection: Readonly<DeclarationReflection>): ReferenceType[];
/**
 * Returns the types the given reflection is implementing.
 * @param reflection The reflection whoes implemented types are wanted.
 * @returns The types the given reflection is implementing.
 */
export declare function getImplementedTypesForReflection(reflection: Readonly<DeclarationReflection>): ReferenceType[];
/**
 * Returns the types that are implementing the given reflection.
 * @param reflection The reflection whoes implementations are wanted.
 * @returns The types that are implementing the given reflection.
 */
export declare function getImplementedBysForReflection(reflection: Readonly<DeclarationReflection>): ReferenceType[];
/**
 * Returns if a reflection has any types above or below it in the class hierarchy.
 * @param reflection The reflection to check.
 * @returns True, if the reflection has any types above or below it in the class hierarchy, otherwise false.
 */
export declare function reflectionIsPartOfClassHierarchy(reflection: Readonly<DeclarationReflection>): boolean;
